trylink: reinstate accidentally deleted --verbose

trylink: remove commented-out parts
This commit is contained in:
Denis Vlasenko 2007-09-03 11:28:14 +00:00
parent fc202427d5
commit 9862e6b056

View File

@ -14,9 +14,8 @@ try() {
BBOX_LIB_LIST=`echo "$BBOX_LIB_LIST" | xargs -n1 | sort | uniq | xargs` BBOX_LIB_LIST=`echo "$BBOX_LIB_LIST" | xargs -n1 | sort | uniq | xargs`
# First link with all libs. If it fails, bail out # First link with all libs. If it fails, bail out
l_list=`echo "$BBOX_LIB_LIST" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
echo "Trying libraries: $BBOX_LIB_LIST" echo "Trying libraries: $BBOX_LIB_LIST"
l_list=`echo "$BBOX_LIB_LIST" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group" test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
try "$l_list" "$@" \ try "$l_list" "$@" \
|| { || {
@ -25,16 +24,8 @@ try "$l_list" "$@" \
exit 1 exit 1
} }
#### Hack disabled: conflicts with ld --verbose flag in last link phase
##### Hack: we are not supposed to know executable name,
##### but this hack cuts down link time
####mv busybox_unstripped busybox_unstripped.tmp
####mv busybox.map busybox.map.tmp
# Now try to remove each lib and build without it. # Now try to remove each lib and build without it.
# Stop when no lib can be removed. # Stop when no lib can be removed.
####ever_discarded=false
while test "$BBOX_LIB_LIST"; do while test "$BBOX_LIB_LIST"; do
$debug && echo "Trying libraries: $BBOX_LIB_LIST" $debug && echo "Trying libraries: $BBOX_LIB_LIST"
all_needed=true all_needed=true
@ -47,7 +38,6 @@ while test "$BBOX_LIB_LIST"; do
echo "Library $one is not needed" echo "Library $one is not needed"
BBOX_LIB_LIST="$without_one" BBOX_LIB_LIST="$without_one"
all_needed=false all_needed=false
#### ever_discarded=true
else else
echo "Library $one is needed" echo "Library $one is needed"
fi fi
@ -60,26 +50,19 @@ while test "$BBOX_LIB_LIST"; do
#{ echo "$BBOX_LIB_LIST" | grep -q ' '; } || break #{ echo "$BBOX_LIB_LIST" | grep -q ' '; } || break
done done
####mv busybox_unstripped.tmp busybox_unstripped # Make the binary with final, minimal list of libs
####mv busybox.map.tmp busybox.map echo "Final link with: $BBOX_LIB_LIST"
####$ever_discarded && { l_list=`echo "$BBOX_LIB_LIST" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
# Make the binary with final, minimal list of libs test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group -Wl,--verbose"
echo "Final link with: $BBOX_LIB_LIST" # --verbose gives us gobs of info to stdout (e.g. linker script used)
l_list=`echo "$BBOX_LIB_LIST" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'` if ! test -f busybox_ldscript; then
# --verbose gives us gobs of info to stdout (e.g. linker script used) try "$l_list -Wl,--verbose" "$@" >busybox_ld.out
test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group -Wl,--verbose" else
if ! test -f busybox_ldscript; then echo "Custom linker script 'busybox_ldscript' found, using it"
# Add SORT_BY_ALIGNMENT to linker script (found in busybox_ld.out):
try "$l_list" "$@" >busybox_ld.out ####|| exit 1 # .rodata : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
else # *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
echo "Custom linker script 'busybox_ldscript' found, using it" # *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
# Add SORT_BY_ALIGNMENT to linker script (found in busybox_ld.out): # This will eliminate most of the data padding (~3kb).
# .rodata : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) } try "$l_list -Wl,--verbose -Wl,-T -Wl,busybox_ldscript" "$@" >busybox_ld.out
# *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*) fi
# *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
# This will eliminate most of the data padding (~3kb).
try "$l_list -Wl,-T -Wl,busybox_ldscript" "$@" >busybox_ld.out
fi
####}
####rm busybox_ld.err
####exit 0 # Ensure "success" exit code